"use strict";

this.name = "xs Black Boa Pirate Freighter AI";

this.aiStarted = function() {
	var ai = new worldScripts["oolite-libPriorityAI"].PriorityAIController(this.ship);

	ai.setParameter("oolite_flag_watchForCargo",true);
	
	ai.setParameter("oolite_flag_allowPlanetaryLanding",true);

	ai.setParameter("oolite_personalityMatchesLeader",0.95);
	if (worldScripts["oolite-libPriorityAI"]._getCommunicationPersonalities("pirate-freighter").length > 0)
	{
		ai.setCommunicationsRole("pirate-freighter");
	}
	else
	{
		ai.setCommunicationsRole("pirate");
	}

	ai.setParameter("oolite_friendlyRoles",["oolite-pirate"]);

	// combat and looting behaviour same at all stages
	var priorities = [
		/* Combat */
		{
			condition: ai.conditionLosingCombat,
			behaviour: ai.behaviourFleeCombat,
			reconsider: 5
		},
		{
			label: "Cargo demands met?",
			condition: ai.conditionCargoDemandsMet,
			/* Let them go if they've dropped enough cargo and stop firing back */
			truebranch: [
				{
					condition: ai.conditionInCombatWithHostiles,
					configuration: ai.configurationAcquireHostileCombatTarget,
					behaviour: ai.behaviourRepelCurrentTarget,
					reconsider: 5
				}
			],
			falsebranch: [
				{
					condition: ai.conditionInCombat,
					configuration: ai.configurationAcquireCombatTarget,
					behaviour: ai.behaviourDestroyCurrentTarget,
					reconsider: 5
				}
			]
		},
		/* Collect loot. Don't worry too much about other group
		 * members. If they pick up stuff too that's good, but this is
		 * the ship with the hold... */
		{
			preconfiguration: ai.configurationCheckScanner,
			condition: ai.conditionScannerContainsSalvageForMe,
			configuration: ai.configurationAcquireScannedTarget,
			behaviour: ai.behaviourCollectSalvage,
			reconsider: 20
		},
		/* Stay away from dangerous stations */
		{
			condition: ai.conditionHostileStationNearby,
			configuration: ai.configurationSetDestinationToNearestStation,
			behaviour: ai.behaviourLeaveVicinityOfDestination,
			reconsider: 20
		},
		/* Are there hunters about? Avoid, or destroy if safe to do so. */
		{
			condition: ai.conditionScannerContainsHunters,
			configuration: ai.configurationAcquireScannedTarget,
			truebranch: [
				{
					condition: ai.conditionCombatOddsExcellent,
					behaviour: ai.behaviourDestroyCurrentTarget,
					reconsider: 10
				},
				{
					behaviour: ai.behaviourLeaveVicinityOfTarget,
					reconsider: 20
				}
			]
		},
		//head for the main planet
		{
			configuration: ai.configurationSetDestinationToMainPlanet,
			behaviour: ai.behaviourApproachDestination,
			reconsider: 30
		}
	];
	ai.setPriorities(priorities);
}
