"use strict";

this.name = "xs Thargoid Courier AI";
this.description = "Thargoid Couriers are more cautious than regular diehard ones.";

this.aiStarted = function() {
	var ai = new worldScripts["oolite-libPriorityAI"].PriorityAIController(this.ship);

	ai.setParameter("oolite_flag_fightsNearHostileStations",true);
	ai.setParameter("oolite_flag_likesInterstellarSpace",true);

	ai.setCommunicationsRole("_thargoid");
	ai.setCommunicationsPersonality("thargoid");

	ai.setPriorities([
		//flee, when in trouble
		{
			condition: ai.conditionLosingCombat,
			behaviour: ai.behaviourFleeCombat,
			reconsider: 5
		},
		{
			condition: ai.conditionCascadeDetected,
			behaviour: ai.behaviourAvoidCascadeExplosion,
			reconsider: 5
		},
		//the basic thargoid behaviour, destroy everything in sight
		{
			condition: ai.conditionHasNonThargoidTarget,
			behaviour: ai.behaviourDestroyCurrentTarget,
			reconsider: 5
		},
		{
			preconfiguration: ai.configurationCheckScanner,
			condition: ai.conditionScannerContainsNonThargoid,
			configuration: ai.configurationAcquireScannedTarget,
			behaviour: ai.behaviourDestroyCurrentTarget,
			reconsider: 1
		},
		{
			condition: ai.conditionInInterstellarSpace,
			configuration: ai.configurationSetDestinationToWitchpoint,
			behaviour: ai.behaviourApproachDestination,
			reconsider: 20
		},
		//if left totally alone and there's nothing to be destroyd around, jump away
		{
			preconfiguration: ai.configurationCheckScanner,
			condition: function() {
				if (this.getParameter("oolite_scanResults").length === 0)
					return true;
				return false;
			},
			behaviour: function() { ship.exitSystem(); },
			reconsider: 20
		},
		//cause some havoc
		{
			configuration: ai.configurationSetDestinationToPirateLurk,
			behaviour: ai.behaviourApproachDestination,
			reconsider: 30
		}
		]);
}
