"use strict";

this.name           = "XeptatlsSword-Main"
this.author         = "Okti,Smivs"
this.copyright      = "(C) Smivs,Okti"
this.description    = "An unusual mission spread into 8 galaxies.";

//this.startUpComplete = function() {
//		worldScripts.Lib_PAD._addPageInCategory("PERSONS.Xeptatl", {name: "Xeptatl", origin:"Thargoid?",species:"Thargoid?",gender:"Unsure",age:,ship:"n/a",rank:"Founder of Xeptatl Society",info:[
//			"Died 2857. Appeared in 2853, after initial Thargoid invasions",
//			"Founder of the Xeptatl Society, opposing the invaders",
//			"Rumoured to have been a dissident Thargoid, leader of a clan",
//			"Most records relating to him were destroyed after his death "],
		//	t0:"lib_pad_xepatl1.png" commented out - is this the problem?
//		})
//	    t0:"lib_pad_rank9.png",t1:"lib_ovc02.png",t2:"lib_pad_medal14.png"}) example from original
//}

this.startUp = function()
{
	this.choiceString = "";
	this.removePylonequipment = false;
	this.neededEmptyPylons = 0;
	this.awardGalDrive = false;
	this.rEquip = false;
	this.timerCount = 0;
	this.misArr = null;
	this.OresratiChalenge = true;
	this.hitCount = 0;
	if(worldScripts["oresratichalange_main"])
	{
		worldScripts.oresratichalange_main.addToCallbacks({worldScript: "XeptatlsSword-Main", callBack: "checkSuspendOresratiChalenge"});
	}
	this.$startUp = true;//mission entities are spawned by populator when entering systems. this is used to prevent spawning on startup.
	this.$ambush = false;//control thargoid ambush in stage 60

	//this is for saving when the finale is running.
	if (missionVariables.XeptatlsSword_status === "STAGE_300") {
		System.infoForSystem(5,55).populator = "xsSystemWillPopulate";
		System.infoForSystem(5,55).repopulator = "xsSystemWillRepopulate";
	}
}

this.startUpComplete = function() {
	this.$startUp = false;
}

this.missionScreenOpportunity = function () {
	if(!this.removePylonequipment) {
		if (player.ship.dockedStation.isMainStation || player.ship.dockedStation.hasRole("xs-station"))
			this.missionScreens();
	}
	else if (missionVariables.XeptatlsSword_status == "STAGE_135" && (player.ship.missileCapacity - player.ship.missiles.length >= 2)) {
		mission.setInstructionsKey("XS_MI_STAGE_140");
		missionVariables.XeptatlsSword_status = "STAGE_140";
		player.ship.awardEquipment("EQ_WARHEAD_MINE");
		player.ship.awardEquipment("EQ_X_SWORD_A_MISSILE");
		mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Leesti_ResearchStation_1"});
		this.removePylonequipment = false;
	}
}

this.missionScreens = function() {
	if (!missionVariables.XeptatlsSword_status) return;
	switch (missionVariables.XeptatlsSword_status) {//"COMPLETED" and "FAILED1" just fall through
		case "OFFER":// initial offer or initial offer delayed
		case "NOT_NOW":
			if (galaxyNumber == 4 && missionVariables.XeptatlsSword_jumpCount >= 3) {
				this.choiceString = "START";
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_start", choicesKey: "XeptatlsSword_start_choices", background: "xs-feather.png"}, this.choices);
			}
			break;
		case "STAGE_0": // Inbe
			if (galaxyNumber == 4 && system.ID == 129) {
				missionVariables.XeptatlsSword_status = "STAGE_1";
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Inbe_a"});
				mission.unmarkSystem({system: 129, name: "xeptatl"});
				mission.setInstructionsKey("XS_MI_STAGE_1");
			}
			break;
		case "STAGE_1": // Estebiin
			if (galaxyNumber == 5 && system.ID == 55 && player.ship.dockedStation.hasRole("xsheadquarters")) {
				this.choiceString = "Estebiin";
				player.credits += 25000;
				missionVariables.XeptatlsSword_jumpCount = 0;
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Estebiin_1", choicesKey: "XeptatlsSword_Estebiin_1_choices", background: "xs-feather.png"}, this.choices);
			}
			break;
		case "STAGE_2d": // Ditere
			if (galaxyNumber == 2 && system.ID == 133)
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Ditere_1", choicesKey: "XeptatlsSword_Ditere_1_choices", background: "xs-feather.png"}, this.choices);
			break;
		case "STAGE_3ab": // Dioris without thargoid computer
		case "STAGE_3ac": // Dioris with thargoid computer
			if (galaxyNumber == 4 && system.ID == 9) {
				if (missionVariables.XeptatlsSword_status === "STAGE_3ab")
					var retrieveText = expandMissionText("XeptatlsSword_Dioris_fail");
				else
					var retrieveText = expandMissionText("XeptatlsSword_Dioris_success");
				missionVariables.XeptatlsSword_status = "STAGE_3a";
				mission.unmarkSystem({system: 9, name: "xeptatl"});
				mission.setInstructionsKey("XS_MI_STAGE_3a");
				//remove special cargo from status screen
				mission.setInstructions(null, "XeptatlsSword-mission-helper");
				mission.runScreen({
					title: "Xeptatl's Sword",
					message: expandMissionText("XeptatlsSword_Dioris") + retrieveText,
					background: "xs-feather.png"
				});
			}
			break;
		case "STAGE_3b": // Qutius
			if (galaxyNumber == 5 && system.ID == 202) {
				missionVariables.XeptatlsSword_status = "STAGE_4";
				mission.markSystem({system: 41, name: "xeptatl"});
				mission.setInstructionsKey("XS_MI_STAGE_4")
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Qutius_1", background: "xs-feather.png"});
				this.$removeHighTechStations();
			}
			break;
		case "STAGE_4": // Beanxeat
			if (galaxyNumber == 5 && system.ID == 41) {
				mission.setInstructionsKey("XS_MI_STAGE_50")
				missionVariables.XeptatlsSword_status = "STAGE_50";
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Beanxeat_1", background: "xs-feather.png"});
			}
			break;
		case "STAGE_50": // Inlabe without completing derelict mission
		case "STAGE_55": // Inlabe with derelict mission
			if (galaxyNumber == 6 && system.ID == 123)
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Inlabe_1",choicesKey: "XeptatlsSword_Inlabe_1_choices", background: "xs-feather.png"}, this.choices);
			break;
		case "STAGE_60": // Tiared
			if (galaxyNumber == 6 && system.ID == 194) {
				mission.setInstructionsKey("XS_MI_STAGE_70")
				missionVariables.XeptatlsSword_status = "STAGE_70";
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Tiared_1", background: "xs-feather.png"});
				mission.unmarkSystem({system: 194, name: "xeptatl"});
			}
			break;
		case "STAGE_71": // Interstellar Space
			if (galaxyNumber == 6 && system.isInterstellarSpace && player.ship.dockedStation.hasRole("X-S-dumbell-station"))
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_ResearchStation_1", choicesKey: "XeptatlsSword_ResearchStation_1_choices", background: "xs-feather.png"}, this.choices);
			break;
		case "STAGE_72": // Articeso
			if (galaxyNumber == 6 && system.ID == 229) {
				mission.setInstructionsKey("XS_MI_STAGE_80")
				missionVariables.XeptatlsSword_status = "STAGE_80";
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Articeso", background: "xs-feather.png"});
				mission.unmarkSystem({system: 229, name: "xeptatl"});
				mission.markSystem({system: 228, name: "xeptatl"});
			}
			break;
		case "STAGE_90": // Onteised
			if (galaxyNumber == 6 && system.ID == 15) {
				mission.setInstructions(null, "XeptatlsSword-mission-helper");
				mission.setInstructionsKey("XS_MI_STAGE_100")
				missionVariables.XeptatlsSword_status = "STAGE_100";
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Onteised", background: "xs-feather.png"});
				mission.unmarkSystem({system: 15, name: "xeptatl"});
			}
			break;
		case "STAGE_100": // Oresrati
			if (galaxyNumber == 7 && system.ID == 162 && player.ship.dockedStation.isMainStation) {
				missionVariables.XeptatlsSword_status = "STAGE_110";
				mission.setInstructionsKey("XS_MI_STAGE_110")
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Oresrati", background: "xs-feather.png"});
				break;//this is here for purpose so that the player can skip stage_100
			}
		case "STAGE_110": // Oresrati Monitoring Station
			if (galaxyNumber == 7 && system.ID == 162 && player.ship.dockedStation.hasRole("damaged-monitor-station")) {
				missionVariables.XeptatlsSword_status = "STAGE_120";
				mission.setInstructionsKey("XS_MI_STAGE_120");
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Oresrati_ResearchStation", background: "xs-feather.png"});
			}
			break;
		case "STAGE_130": // Diso monitor station
			if (galaxyNumber == 0 && system.ID == 147 && player.ship.dockedStation.hasRole("xsMonitorStation")) {
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Diso_ResearchStation", model: "EQ_X_SWORD_MISSILE", choicesKey: "XeptatlsSword_Diso_ResearchStation_choices", background: "xs-feather.png"}, this.choices);
				//remove special cargo from status screen
				mission.setInstructions(null, "XeptatlsSword-mission-helper");
			}
			break;
		case "STAGE_140": // Diso main station
			if (galaxyNumber == 0 && system.ID == 147 && player.ship.dockedStation.isMainStation) {
				missionVariables.XeptatlsSword_status = "STAGE_150";
				mission.unmarkSystem({system: 147, name: "xeptatl"});
				mission.markSystem({system: 7, name: "xeptatl"});
				mission.setInstructionsKey("XS_MI_STAGE_150");
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Diso", background: "xs-feather.png"});
			}
			break;
		case "STAGE_180": // Lave
			if (galaxyNumber == 0 && system.ID == 7 && player.ship.dockedStation.isMainStation) {
				missionVariables.XeptatlsSword_status = "STAGE_200";
				mission.unmarkSystem({system: 7, name: "xeptatl"});
				mission.setInstructions(null);
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Lave_a1", choicesKey: "XeptatlsSword_Lave_a1_choices", background: "xs-feather.png"}, this.choices);
			}
			break;
		case "STAGE_160": // Lave Unsucsesfull
			if (galaxyNumber == 0 && player.ship.dockedStation.isMainStation) {
				missionVariables.XeptatlsSword_status = "STAGE_170";
				mission.unmarkSystem({system: 7, name: "xeptatl"});
				mission.setInstructions(null);
				if (system.ID == 7)
					mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Lave_b1", choicesKey: "XeptatlsSword_Lave_b1_choices", background: "xs-feather.png"}, this.choices);
				else // Not Lave Unsucesfull
					mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Lave_c1", choicesKey: "XeptatlsSword_Lave_b1_choices", background: "xs-feather.png"}, this.choices);
			}
			break;
		case "STAGE_200": // Tionisla
			if (galaxyNumber == 0 && system.ID == 124 && player.ship.dockedStation.isMainStation) {
				mission.setInstructionsKey("XS_MI_STAGE_205");
				missionVariables.XeptatlsSword_status = "STAGE_205";
				mission.unmarkSystem({system: 124, name: "xeptatl"});
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Tionisla", choicesKey: "XeptatlsSword_Tionisla_choices", background: "xs-feather.png"}, this.choices);
			}
			break;
		case "STAGE_205": // Vearin
			if (galaxyNumber == 1 && system.ID == 250 && player.ship.dockedStation.isMainStation) {
				mission.setInstructionsKey("XS_MI_STAGE_210");
				missionVariables.XeptatlsSword_status = "STAGE_210";
				mission.unmarkSystem({system: 250, name: "xeptatl"});
				mission.markSystem({system: 229, name: "xeptatl"});
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Vearin", background: "xs-feather.png"});
			}
			break;
		case "STAGE_210": // Lasoce
			if (galaxyNumber == 1 && system.ID == 229 && player.ship.dockedStation.isMainStation) {
				mission.setInstructionsKey("XS_MI_STAGE_215");
				missionVariables.XeptatlsSword_status = "STAGE_215";
				mission.unmarkSystem({system: 229, name: "xeptatl"});
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Lasoce", background: "xs-feather.png"});
			}
			break;
		case "STAGE_215": // Soiserla
			if (galaxyNumber == 2 && system.ID == 63 && player.ship.dockedStation.isMainStation) {
				mission.setInstructionsKey("XS_MI_STAGE_220");
				missionVariables.XeptatlsSword_status = "STAGE_220";
				mission.unmarkSystem({system: 63, name: "xeptatl"});
				mission.markSystem({system: 36, name: "xeptatl"});
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Soiserla", background: "xs-feather.png"});
			}
			break;
		case "STAGE_220": // Birera
			if (galaxyNumber == 2 && system.ID == 36 && player.ship.dockedStation.isMainStation) {
				mission.setInstructionsKey("XS_MI_STAGE_225");
				missionVariables.XeptatlsSword_status = "STAGE_225";
				mission.unmarkSystem({system: 36, name: "xeptatl"});
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Birera", background: "xs-feather.png"});
			}
			break;
		case "STAGE_225": // Aaanqu
			if (galaxyNumber == 3 && system.ID == 236 && player.ship.dockedStation.isMainStation) {
				mission.setInstructionsKey("XS_MI_STAGE_230");
				missionVariables.XeptatlsSword_status = "STAGE_230";
				mission.unmarkSystem({system: 236, name: "xeptatl"});
				mission.markSystem({system: 178, name: "xeptatl"});
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Aaanqu", background: "xs-feather.png"});
			}
			break;
		case "STAGE_230": // Soralaat
			if (galaxyNumber == 3 && system.ID == 178 && player.ship.dockedStation.isMainStation) {
				mission.setInstructionsKey("XS_MI_STAGE_235");
				missionVariables.XeptatlsSword_status = "STAGE_235";
				mission.unmarkSystem({system: 178, name: "xeptatl"});
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Soralaat", background: "xs-feather.png"});
			}
			break;
		case "STAGE_235": // Geerin
			if (galaxyNumber == 4 && system.ID == 83 && player.ship.dockedStation.isMainStation) {
				mission.setInstructionsKey("XS_MI_STAGE_240");
				missionVariables.XeptatlsSword_status = "STAGE_240";
				mission.unmarkSystem({system: 83, name: "xeptatl"});
				mission.markSystem({system: 15, name: "xeptatl"});
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Geerin", background: "xs-feather.png"});
			}
			break;
		case "STAGE_245": // Aroratla
			if (galaxyNumber == 4 && system.ID == 217 && player.ship.dockedStation.isMainStation) {
				mission.setInstructionsKey("XS_MI_STAGE_250");
				missionVariables.XeptatlsSword_status = "STAGE_250";
				mission.unmarkSystem({system: 217, name: "xeptatl"});
				mission.markSystem({system: 196, name: "xeptatl"});
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Aroratla", background: "xs-feather.png"});
			}
			break;
		case "STAGE_255": // Xeaten
			if (galaxyNumber == 4 && system.ID == 229 && player.ship.dockedStation.isMainStation) {
				mission.setInstructionsKey("XS_MI_STAGE_260");
				missionVariables.XeptatlsSword_status = "STAGE_260";
				mission.unmarkSystem({system: 229, name: "xeptatl"});
				mission.markSystem({system: 123, name: "xeptatl"});
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Xeaten", background: "xs-feather.png"});
			}
			break;
		case "STAGE_260": // Quinmabe
			if (galaxyNumber == 4 && system.ID == 123 && player.ship.dockedStation.isMainStation) {
				mission.setInstructionsKey("XS_MI_STAGE_265");
				missionVariables.XeptatlsSword_status = "STAGE_265";
				mission.unmarkSystem({system: 123, name: "xeptatl"});
				mission.markSystem({system: 223, name: "xeptatl"});
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Quinmabe", background: "xs-feather.png"});
			}
			break;
		case "STAGE_265": // Ceenbion
			if (galaxyNumber == 4 && system.ID == 223 && player.ship.dockedStation.isMainStation) {
				mission.setInstructionsKey("XS_MI_STAGE_270");
				missionVariables.XeptatlsSword_status = "STAGE_270";
				mission.unmarkSystem({system: 223, name: "xeptatl"});
				mission.markSystem({system: 170, name: "xeptatl"});
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Ceenbion", background: "xs-feather.png"});
			}
			break;
		case "STAGE_270": // Tecexe
			if (galaxyNumber == 4 && system.ID == 170 && player.ship.dockedStation.isMainStation) {
				mission.setInstructionsKey("XS_MI_STAGE_275");
				missionVariables.XeptatlsSword_status = "STAGE_275";
				mission.unmarkSystem({system: 170, name: "xeptatl"});
				mission.markSystem({system: 194, name: "xeptatl"});
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Tecexe", background: "xs-feather.png"});
			}
			break;
		case "STAGE_275": // Zalexe
			if (galaxyNumber == 4 && system.ID == 194 && player.ship.dockedStation.isMainStation) {
				mission.setInstructionsKey("XS_MI_STAGE_280");
				missionVariables.XeptatlsSword_status = "STAGE_280";
				mission.unmarkSystem({system: 194, name: "xeptatl"});
				mission.markSystem({system: 77, name: "xeptatl"});
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Zalexe", background: "xs-feather.png"});
			}
			break;
		case "STAGE_280": // Biradi
			if (galaxyNumber == 4 && system.ID == 77 && player.ship.dockedStation.isMainStation) {
				mission.setInstructionsKey("XS_MI_STAGE_285");
				missionVariables.XeptatlsSword_status = "STAGE_285";
				mission.unmarkSystem({system: 77, name: "xeptatl"});
				mission.markSystem({system: 179, name: "xeptatl"});
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Biradi", background: "xs-feather.png"});
			}
			break;
		case "STAGE_285": // Atmaa
			if (galaxyNumber == 4 && system.ID == 179 && player.ship.dockedStation.isMainStation) {
				mission.setInstructionsKey("XS_MI_STAGE_290");
				missionVariables.XeptatlsSword_status = "STAGE_290";
				mission.unmarkSystem({system: 179, name: "xeptatl"});
				mission.markSystem({system: 197, name: "xeptatl"});
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Atmaa", background: "xs-feather.png"});
			}
			break;
		case "STAGE_295": // Dioris
			if (galaxyNumber == 4 && system.ID == 9 && player.ship.dockedStation.isMainStation) {
				mission.setInstructionsKey("XS_MI_STAGE_300");
				missionVariables.XeptatlsSword_status = "STAGE_300";
				mission.unmarkSystem({system: 9, name: "xeptatl"});
				mission.markSystem({system: 129, name: "xeptatl"});
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Dioris_2", choicesKey: "XeptatlsSword_Dioris_2_choices", background: "xs-feather.png"}, this.choices)
			}
			break;
		case "STAGE_300": // Estebiin
			if (galaxyNumber == 5 && system.ID == 55 && player.ship.dockedStation.hasRole("xsheadquarters")) {
				mission.setInstructionsKey("XS_MI_STAGE_310");
				missionVariables.XeptatlsSword_status = "STAGE_310";
				missionVariables.CrippledAnni = "FALSE";
				player.ship.awardEquipment("EQ_XS_SWORD_MISSILE");
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Estebiin_4", choicesKey: "XeptatlsSword_Estebiin_4_choices", background: "xs-feather.png"}, this.choices);
			}
			break;
		case "STAGE_340": // Estebiin Final A
			if (galaxyNumber == 5 && system.ID == 55 && player.ship.dockedStation.hasRole("xsheadquarters")) {
				mission.setInstructionsKey(null);
				missionVariables.XeptatlsSword_status = "STAGE_360";
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Estebiin_FinalA_1", choicesKey: "XeptatlsSword_Estebiin_FinalA_1_choices", background: "xs-feather.png"}, this.choices);
			}
			break;
		case "STAGE_350": // Estebiin Final B
			if (galaxyNumber == 5 && system.ID == 55 && player.ship.dockedStation.hasRole("xsheadquarters")) {
				mission.setInstructionsKey(null);
				missionVariables.XeptatlsSword_status = "STAGE_360";
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Estebiin_FinalB_1", choicesKey: "XeptatlsSword_Estebiin_FinalB_1_choices", background: "xs-feather.png"}, this.choices);
			}
	}
}

this.choices = function(choice)
{
	switch(choice)
		{
		case "1_Yes":
		{
			missionVariables.XeptatlsSword_jumpCount = null;
			missionVariables.XeptatlsSword_status = "STAGE_0";
			mission.setInstructionsKey("XS_MI_STAGE_0");
			mission.markSystem({system: 129, name: "xeptatl"});
			mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_start_2", background: "xs-feather.png"});
			break;
		}
		case "2_No":
		{
			missionVariables.XeptatlsSword_jumpCount = 0;
			missionVariables.XeptatlsSword_status = "NOT_NOW";
			break;
		}
		case "1_Cont":
		{
			player.credits += 10000;
			mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Estebiin_2", choicesKey: "XeptatlsSword_Estebiin_2_choices", background: "xs-feather.png"},this.choices);
			break;
		}
		case "1a_Cont":
		{
			missionVariables.XeptatlsSword_status = "STAGE_2a";
			mission.setInstructionsKey("XS_MI_STAGE_2a");
			missionVariables.XeptatlsSword_status = "STAGE_2a";
			player.credits += 20000;
			mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Estebiin_3", background: "xs-feather.png"});
			break;
		}
		case "2_Cont":
		{
			mission.setInstructionsKey("XS_MI_STAGE_3");
			missionVariables.XeptatlsSword_status = "STAGE_3";
			missionVariables.XeptatlsSword_jumpCount = 0;
			mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Ditere_2", background: "xs-feather.png"});
			break;
		}
		case "3_Cont":
		{
			mission.setInstructionsKey("XS_MI_STAGE_60")
			missionVariables.XeptatlsSword_status = "STAGE_60";
			mission.markSystem({system: 194, name: "xeptatl"});
			mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Inlabe_2", background: "xs-feather.png"});
			break;
		}
		case "4a_Cont":
		{
			mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_ResearchStation_2", choicesKey: "XeptatlsSword_ResearchStation_2_choices", background: "xs-feather.png"}, this.choices);
			break;
		}
		case "4b_Cont":
		{
			mission.markSystem({system: 229, name: "xeptatl"});
			mission.setInstructionsKey("XS_MI_STAGE_72")
			missionVariables.XeptatlsSword_status = "STAGE_72";
			player.ship.fuel = 7.0;
			this.warningSound = new SoundSource;
			this.warningSound.sound = "emergency030.ogg";
			this.warningSound.loop = true;
			this.warningSound.play();
			mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_ResearchStation_3", choicesKey: "XeptatlsSword_ResearchStation_3_choices", background: "xs-feather.png"}, this.choices);
			break;
		}
		case "4c_Cont": {
			player.ship.launch();
			break;
		}
		case "5_Cont":
		{
			if(player.ship.missileCapacity - player.ship.missiles.length >= 2)
			{
				mission.setInstructionsKey("XS_MI_STAGE_140")
				missionVariables.XeptatlsSword_status = "STAGE_140";
				player.ship.awardEquipment("EQ_WARHEAD_MINE");
				player.ship.awardEquipment("EQ_X_SWORD_A_MISSILE");
				mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Leesti_ResearchStation_1", background: "xs-feather.png"});
				break;
			}
			else
			{
				missionVariables.XeptatlsSword_status = "STAGE_135";
				this.removePylonequipment = true;
				this.neededEmptyPylons = 2;
				break;
			}
		}
		case "6_Cont":
		{
			mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Lave_a2", choicesKey: "XeptatlsSword_Lave_a2_choices", background: "xs-feather.png"}, this.choices);
			break;
		}
		case "6a_Cont":
		{
			mission.setInstructionsKey("XS_MI_STAGE_200")
			player.credits += 100000;
			mission.markSystem({system: 124, name: "xeptatl"});
			mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Lave_a3", background: "xs-feather.png"});
			break;
		}
		case "7a_Cont":
		{
			mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Estebiin_5", model: "EQ_XS_SWORD_MISSILE", choicesKey: "XeptatlsSword_Estebiin_5_choices", background: "xs-feather.png"}, this.choices);
			break;
		}
		case "7b_Cont":
		{
			mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Estebiin_6", choicesKey: "XeptatlsSword_Estebiin_6_choices",overlay: { name: "spikes.png", height: 512 }, background: "xs-feather.png"}, this.choices);
			break;
		}
		case "7c_Cont":
		{
			mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Estebiin_7",overlay: { name: "target.png", height: 512 }, background: "xs-feather.png"});
			break;
		}
		case "8a_Cont":
		{
			mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Estebiin_FinalA_2", background: "xs-feather.png"});
			break;
		}
		case "8b_Cont":
		{
			mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Estebiin_FinalB_2", background: "xs-feather.png"});
			break;
		}
		case "6b_Cont":
		{
			player.ship.dockedStation.explode();
			break;
		}
		case "16_Cont":
		{
			mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Tionisla_2", background: "xs-feather.png"});
			break;
		}
		case "17_Cont":
		{
			mission.runScreen({title: "Xeptatl's Sword", messageKey: "XeptatlsSword_Dioris_3", background: "xs-feather.png"});
			break;
		}
	}
}

this.shipLaunchedFromStation = function(station) {
	if (missionVariables.XeptatlsSword_status) {
		switch (missionVariables.XeptatlsSword_status) {
			//it's possible to save somewhere elsewhere than the main station so this is needed
			case "STAGE_4":
			case "STAGE_50":
				if (galaxyNumber == 5 && system.ID == 41)
					this.$removeHighTechStations();
				break;
		}
	}
}

this.systemWillPopulate = function (){
	//permanent entities.

	//monitor stations
	if (galaxyNumber == 0 && system.ID == 205)
		var monitorPos = Vector3D(0, 0, 3).fromCoordinateSystem("sps");
	else if (galaxyNumber == 0 && system.ID == 147)
		var monitorPos = Vector3D(0, 0, 3).fromCoordinateSystem("sws");
	if (monitorPos) {
		system.setPopulator("xs_monitor_station", {
			callback: function(pos) {
				system.addShips("xsMonitorStation", 1, pos);
			}.bind(this),
			location: "COORDINATES",
			coordinates: monitorPos
		});
	}
	//Oresrati station
	//for consistency there's always a station. it's damaged on selected stages
	if (galaxyNumber == 7 && system.ID == 162) {
		var damagedStages = ["STAGE_100", "STAGE_110", "STAGE_120"];
		var monitorPos = Vector3D(0, 0, 3).fromCoordinateSystem("sps");
		system.setPopulator("xs_monitor_station", {
			callback: function(pos) {
				if (missionVariables.XeptatlsSword_status && damagedStages.indexOf(missionVariables.XeptatlsSword_status) !== -1)
					system.addShips("damaged-monitor-station", 1, pos);
				else system.addShips("xsMonitorStation", 1, pos);
			}.bind(this),
			location: "COORDINATES",
			coordinates: monitorPos
		});
	}
	//headquarters
	if (galaxyNumber == 5 && system.ID == 55)
		var hqPos = Vector3D(0, 0, 0.1).fromCoordinateSystem("psu");
	if (hqPos) {
		system.setPopulator("xs_headquarters", {
			callback: function(pos) {
				system.addShips("xsheadquarters", 1, pos, 0);
			}.bind(this),
			location: "COORDINATES",
			coordinates: hqPos
		});
	}

	//mission entities / progress

	if (missionVariables.XeptatlsSword_status) {
		//this we do in witchspace exit
		if (!this.$startUp) {
			switch (missionVariables.XeptatlsSword_status) {
				case "STAGE_0" :
					if (galaxyNumber == 4 && system.ID == 129) {
						system.setPopulator("xs_mission", {
							callback: function(pos) {
								system.addShips("thargoid", 2, pos, 7500);
							}.bind(this),
							location: "COORDINATES",
							coordinates: [0, 0, 0]}
						);
					}
					break;
				//spawn s special courier only if the player has not encountered one yet
				case "STAGE_3" :
					if (galaxyNumber == 3 && system.ID === 141) {
						system.setPopulator("xs_mission", {
							callback: function(pos) {
								system.addShips("thargoid_courier",1,pos,3000);
							}.bind(this),
							location: "COORDINATES",
							coordinates: [0, 0, 0]}
						);
					}
					break;

				case "STAGE_60" :
					if (!missionVariables.XeptatlsSword_jumpCount || missionVariables.XeptatlsSword_jumpCount === 0)
						missionVariables.XeptatlsSword_jumpCount = Math.floor(Math.random() * 3);
					else missionVariables.XeptatlsSword_jumpCount += 1;
					if (missionVariables.XeptatlsSword_jumpCount > 5 || system.ID == 249 || system.ID == 166) {
						system.setPopulator("xs_mission", {
							callback: function(pos) {
								missionVariables.XeptatlsSword_jumpCount = 0;
								var tCount = Math.floor(Math.random() * 3) +2;
								this.$ambush = true;
								system.addShips("thargoid", tCount, pos, 7500);
								if(system.ID == 249 || system.ID == 166) {
									system.addShips("thargoid", 5, pos, 7500);
									system.addShips("xsProllyG7", 1, pos, 7500);
								}
								else
									system.addShips("thargoid", tCount, pos, 7500);
							}.bind(this),
							location: "COORDINATES",
							coordinates: [0, 0, 0]}
						);
					}
					break;
				case "STAGE_240" :
				case "STAGE_250" :
				case "STAGE_290" :
					if (galaxyNumber == 4 && (system.ID == 15 || system.ID == 196 || system.ID == 197)) {
						system.setPopulator("xs_mission", {
							callback: function(pos) {
								this.traderShip = system.addShips("trader", 1, pos , 3000)[0];
								this.messageTimer = new Timer(this,this.mesTimer,7,0);
							}.bind(this),
							location: "COORDINATES",
							coordinates: [0, 0, 0]}
						);
					}
					break;
				case "STAGE_260" :
				case "STAGE_280" :
					if (galaxyNumber == 4 && (system.ID == 123 || system.ID == 77)) {
						system.setPopulator("xs_mission", {
							callback: function(pos) {
								this.Anni = system.addShips("xs_thargoid_disc", 1, pos, 10)[0];
								this.FrisbeeTimerCount = 0;
								this.materialTimerx = new Timer(this,this.setMaterials2,4,4);
							}.bind(this),
							location: "COORDINATES",
							coordinates:[0, 0, -18000]}
						);
					}
					break;
			}
		}
		//these we do in both startup and witchspace exit
		switch (missionVariables.XeptatlsSword_status) {
			case "STAGE_50":
				if (galaxyNumber == 5 && system.ID == 41) {
					var wreckPosition = Vector3D(0, 0, - system.sun.radius * 4).fromCoordinateSystem("spm");
					system.setPopulator("xs_mission", {
						callback: function(pos) {
							system.addShips("asteroid", 9, pos, 5000);
							system.addShips("spacewreck_anaconda", 1, pos);
						}.bind(this),
						location: "COORDINATES",
						coordinates: wreckPosition}
					);
				}
				break;
			case "STAGE_80":
				if (galaxyNumber == 6 && system.ID == 228) {
					system.setPopulator("xs_mission", {
						callback: function(pos) {
							system.addShips("crystaloid", 2, pos);
							system.addShips("xsProlly", 1, pos);
						}.bind(this),
						location: "COORDINATES",
						coordinates: Vector3D(0, 0, 3).fromCoordinateSystem("sps")}
					);
				}
				break;
		}

	}
}

//special replacement populator for stage_71
this.xsInterstellarSpaceWillPopulate = function() {
	system.setPopulator("xs_mission", {
		callback: function(pos) {
			system.addShips("X-S-dumbell-station", 1, pos, 12000);
		}.bind(this),
		location: "COORDINATES",
		coordinates: [0, 0, 0]}
	);
	SystemInfo.setInterstellarProperty(6, 194, 89, 2, "populator", null);
	SystemInfo.setInterstellarProperty(6, 194, 89, 2, "repopulator", null);
}

//special populator for stages 160 & 300
this.xsSystemWillPopulate = function() {
	system.setPopulator("xs-nav-buoy",
		{
			priority: 5,
			location: "COORDINATES",
			coordinates: system.mainStation.position.add(system.mainStation.vectorForward.multiply(10E3)),
			callback: function(pos) {
				var nb = system.addShips("buoy",1,pos,0)[0];
				nb.scanClass = "CLASS_BUOY";
				nb.reactToAIMessage("START_TUMBLING");
				nb.beaconLabel = "[oolite-beacon-label-station]";
				nb.xsMainStationBuoy = true;
			},
			deterministic: true
		});
	//only mainstation buoy remains in stage 160.
	if (missionVariables.XeptatlsSword_status !== "STAGE_160") {
		system.setPopulator("xs-witch-buoy",
			{
				priority: 10,
				location: "COORDINATES",
				coordinates: [0,0,0],
				callback: function(pos) {
					var wb = system.addShips("buoy-witchpoint",1,pos,0)[0];
					wb.scanClass = "CLASS_BUOY";
					wb.reactToAIMessage("START_TUMBLING");
					wb.beaconLabel = "[oolite-beacon-label-witchpoint]";
				},
				deterministic: true
			});
	}

	//in stage 160 everything else has been wiped away, only ps asteroids remain.

	var clusters = 2*(1+Math.floor(system.scrambledPseudoRandomNumber(51728)*4));
	var psclusters = 1+(clusters/2);

	var addRockCluster = function(pos)
	{
		var size = 1+Math.floor(system.scrambledPseudoRandomNumber(Math.floor(pos.x))*11);
		var hermit = (system.scrambledPseudoRandomNumber(Math.floor(pos.y))*31) <= size;
		var rocks = system.addShips("asteroid",size,pos,25E3);

		//no hermits in stage 160
		if (missionVariables.XeptatlsSword_status !== "STAGE_160" && hermit && !system.sun.isGoingNova)
		{
				var allegiance = this.$xsHermitAllegiance(pos,system.info.government);
				var role = "rockhermit";
				if (allegiance == "chaotic")
				{
						role = "rockhermit-chaotic";
				}
				else if (allegiance == "pirate")
				{
						role = "rockhermit-pirate";
				}

				var rh = system.addShips(role,1,pos,0)[0];
				rh.scanClass = "CLASS_ROCK";
		}
	}.bind(this);

	//no wp asteroids in stage 160
	if (missionVariables.XeptatlsSword_status !== "STAGE_160") {
		system.setPopulator("xs-route1-asteroids",
			{
				priority: 20,
				location: "LANE_WP",
				locationSeed: 51728,
				groupCount: clusters,
				callback: addRockCluster,
				//the player can't save at a hermit when the mission is running.
				deterministic: false
			});
	}

	system.setPopulator("xs-route2-asteroids",
			{
				priority: 20,
				location: "LANE_PS",
				locationSeed: 82715,
				groupCount: psclusters,
				callback: addRockCluster,
				//the player can't save at a hermit when the mission is running.
				deterministic: false
			});

	//no offlane hermits in stage 160
	if (missionVariables.XeptatlsSword_status !== "STAGE_160") {
        system.setPopulator("xs-offlane-hermit",
			{
				priority: 99, // make sure all other core population is done
				location: "PLANET_ORBIT_HIGH",
				locationSeed: 71258,
				groupCount: 1,
				callback: function(pos) {
					if (system.countShipsWithPrimaryRole("rockhermit")+system.countShipsWithPrimaryRole("rockhermit-chaotic")+system.countShipsWithPrimaryRole("rockhermit-pirate")==0) {
						var allegiance = this.$xsHermitAllegiance(pos,system.info.government);
						var role = "rockhermit";
						if (allegiance == "chaotic")
						{
								role = "rockhermit-chaotic";
						}
						else if (allegiance == "pirate")
						{
								role = "rockhermit-pirate";
						}
						var rh = system.addShips(role,1,pos,0)[0];
						// just the hermit, no other rocks
						rh.scanClass = "CLASS_ROCK";
                                                                }
				}.bind(this),
				//the player can't save at a hermit when the mission is running.
				deterministic: false
			});
	}

	//the baddies for stage 160
	if (missionVariables.XeptatlsSword_status === "STAGE_160" && galaxyNumber == 0) {
		system.setPopulator("xs_mission", {
			callback: function(pos) {
				this.tharGroup = system.addGroupToRoute("thargoid", 5, 0.9, "wp");
				var sHive = system.addShips("thargoid-hive",1 ,this.tharGroup.ships[0].position,5000)[0];
				tharGroup.leader = sHive;
				var ships = system.addShips("blitznestLave",5 ,this.tharGroup.ships[0].position,10000);
				var sDisc = system.addShips("xs_thargoid_disc",1 ,this.tharGroup.ships[0].position,20000)[0];
				this.tharGroup.addShip(sDisc);
				var j = 0;
				while(j < ships.length)
				{
					this.tharGroup.addShip(ships[j]);
					j +=1;
				}
			}.bind(this),
			location: "LANE_WP"}
		);
	}

	//headquarter & thunderchild for stage 300
	if (missionVariables.XeptatlsSword_status === "STAGE_300" && galaxyNumber === 5) {
		var hqPos = Vector3D(0, 0, 0.1).fromCoordinateSystem("psu");
		system.setPopulator("xs_headquarters", {
			callback: function(pos) {
				var hq = system.addShips("xsheadquarters", 1, pos, 0)[0];
				this.$TV = hq.position.direction();
				this.$TC = system.addShips("thunderchild",1,hq.position.add(this.$TV.multiply(15000)),100)[0];
			}.bind(this),
			location: "COORDINATES",
			coordinates: hqPos
		});
	}


	//reset populators.
	if (missionVariables.XeptatlsSword_status === 160) {
		System.infoForSystem(0,7).populator = null;
		System.infoForSystem(0,7).repopulator = null;
	}
	else {
		System.infoForSystem(5,55).populator = null;
		System.infoForSystem(5,55).repopulator = null;
	}
}

//this is copied straight from the core game
this.$xsHermitAllegiance = function(position,government)
{
	// default hermit status, allows all dockings but pirates will tend to
	// go elsewhere. We set this in shipdata but a shipset might not
	var allegiance = "neutral";
	if ((Math.floor(Math.abs(position.z)) % 4) * (Math.floor(Math.abs(position.y)) % 4) > government)
	{
		// pirates will use this hermit for docking and launching, but
		// other ships might too
		allegiance = "chaotic";
		if (Math.abs(Math.floor(position.x) % 4) > government+1)
		{
				// in Feudal or Anarchy systems, some of the hermits are
				// so pirate-friendly that legitimate traffic avoids them
				allegiance = "pirate";
		}
	}
	return allegiance;
}


this.shipExitedWitchspace = function() {
	if (missionVariables.XeptatlsSword_status) {
		switch (missionVariables.XeptatlsSword_status) {
			case "OFFER" :
			case "NOT_NOW" :
				if (galaxyNumber == 4)
					missionVariables.XeptatlsSword_jumpCount += 1;
				break;
			case "STAGE_0" :
				if (galaxyNumber == 4 && system.ID == 129)
					this.$thargoidAmbush();
				break;
			case "STAGE_3a" :
				if (galaxyNumber == 5 && system.ID == 202) {
					player.ship.energy = player.ship.energy/2;
					player.ship.forwardShield = 0;
					if(player.ship.equipmentStatus("EQ_GAL_DRIVE") == "EQUIPMENT_OK")
						player.ship.removeEquipment("EQ_GAL_DRIVE");
					while (player.ship.removeEquipment("EQ_GAL_DRIVE_MINE"));
					player.consoleMessage("Due to Witchspace turbulence, your GalDrivePod is damaged beyond repair.",6);
					missionVariables.XeptatlsSword_status = "STAGE_3b";
				}
				break;
			case "STAGE_60" :
				if (this.$ambush) {
					this.$thargoidAmbush();
					player.consoleMessage("Ambush!",6);
				}
				this.$ambush = false;
				break;
			//make sure there's no one else around
			case "STAGE_71" :
				if (system.isInterstellarSpace && system.countShipsWithRole("X-S-dumbell-station")) {
					var shArr = system.allShips;
					var j = shArr.length-1;
					while (j > 0) {
						if (!shArr[j].hasRole("X-S-dumbell-station"))
							shArr[j].remove(true);
						j -= 1;
					}
				}
				break;
			case "STAGE_80" :
				if (galaxyNumber == 6 && system.ID == 228)
					player.commsMessage("Prollykanteraprillito: I am out near the Sun, Commander. Make your way here immediately.", 5);
				break;
			case "STAGE_160" :
				if (galaxyNumber == 0 && system.ID == 7) {
					//make sure there's no one else around
					var shArr = system.allShips;
					var j = shArr.length-1;
					while (j > 0) {
						if (!shArr[j].isMainStation && !shArr[j].isRock && !shArr[j].isThargoid && !shArr[j].xsMainStationBuoy)
							shArr[j].remove(true);
						j -= 1;
					}
					player.commsMessage("Main Station: This system is under Thargoid control and all our ships have been lost. The Hive must be destroyed! ",10);
				}
				break;
			//anticheat
			case "STAGE_4":
			case "STAGE_50":
				if (galaxyNumber == 5 && system.ID == 41)
					this.$removeHighTechStations();
				break;
		}
	}
	else if (galaxyNumber == 4) {
		if (missionVariables.cloak == "COMPLETE") {
			missionVariables.XeptatlsSword_status="OFFER";
			missionVariables.XeptatlsSword_jumpCount = 0;
		}
	}
	if(this.awardGalDrive == true)
	{
		player.ship.awardEquipment("EQ_GAL_DRIVE");
		player.commsMessage("Galactic Hyperdrive is operational",6);
		this.awardGalDrive = false;
	}
}

this.shipWillExitWitchspace = function() {
	if(galaxyNumber == 5 && system.ID == 55) {
		if(missionVariables.XeptatlsSword_status == "STAGE_300") {
			var shArr = system.allShips;
			var j =shArr.length-1;
			//try to make sure there's nothing "extra" content in system
			while (j > 0)
			{
				if (!shArr[j].isMainStation && !shArr[j].isBeacon && !shArr[j].isRock) {
					log("test", shArr[j]);
					shArr[j].remove(true);
				}
				j -= 1;
			}
			player.commsMessage("Welcome Commander. Please make your way directly to the Xeptatl Society Headquarters Station.",10);
		}
	}
}


this.shipWillEnterWitchspace = function(cause)
{
	this.awardGalDrive = false;
	if (missionVariables.XeptatlsSword_status) {
		if (cause == "galactic jump" && galaxyNumber == 4 && missionVariables.XeptatlsSword_status == "STAGE_3a")
			mission.unmarkSystem({system: 9, name: "xeptatl"});
		if (galaxyNumber == 6 && system.ID == 194 && missionVariables.XeptatlsSword_status == "STAGE_70" && player.ship.targetSystem == 89) {
			missionVariables.XeptatlsSword_status = "STAGE_71";
			SystemInfo.setInterstellarProperty(6, 194, 89, 2, "populator", "xsInterstellarSpaceWillPopulate");
			SystemInfo.setInterstellarProperty(6, 194, 89, 2, "repopulator", "xsInterstellarSpaceWillRepopulate");
		}

		if (galaxyNumber == 0 && missionVariables.XeptatlsSword_status == "STAGE_150" && player.ship.targetSystem == 7) {
			missionVariables.XeptatlsSword_status = "STAGE_160";
			System.infoForSystem(0,7).populator = "xsSystemWillPopulate";
			System.infoForSystem(0,7).repopulator = "xsSystemWillRepopulate";
		}
		if (missionVariables.XeptatlsSword_status === "STAGE_300") {
			System.infoForSystem(5,55).populator = "xsSystemWillPopulate";
			System.infoForSystem(5,55).repopulator = "xsSystemWillRepopulate";
		}
	}
	//remove annihilator countermeasures, if present
	if (this.shipSpawned) delete this.shipSpawned;
}

this.playerEnteredNewGalaxy = function(galNum) {
	player.commsMessage("Welcome to Galaxy " + (galaxyNumber+1),6);
	this.$courier = false;//make sure thargoid couriers only appear in stage_3
	if (missionVariables.XeptatlsSword_status) {
		switch (missionVariables.XeptatlsSword_status) {
			case "STAGE_2a" :
				if(galaxyNumber==1) {
					mission.markSystem({system: 105, name: "xeptatl"});
					missionVariables.XeptatlsSword_status = "STAGE_2d";
				}
				break;
			case "STAGE_3" :
				if(galaxyNumber===3)
					mission.markSystem({system: 141, name: "xeptatl"});
				break;
			case "STAGE_3a" :
				if(galaxyNumber==4)
					mission.markSystem({system: 9, name: "xeptatl"});
				break;
			case "STAGE_130" :
				if(galaxyNumber==0)
					mission.markSystem({system: 147, name: "xeptatl"});
				break;
			case "STAGE_205" :
				if(galaxyNumber==1)
					mission.markSystem({system: 250, name: "xeptatl"});
				break;
			case "STAGE_215" :
				if(galaxyNumber==2)
					mission.markSystem({system: 63, name: "xeptatl"});
				break;
			case "STAGE_225" :
				if(galaxyNumber==3)
					mission.markSystem({system: 236, name: "xeptatl"});
				break;
			case "STAGE_235" :
				if(galaxyNumber==4)
					mission.markSystem({system: 83, name: "xeptatl"});
				break;
			case "STAGE_300" :
				if(galaxyNumber==5) {
					mission.markSystem({system: 55, name: "xeptatl"});
					//prevent the player from jumping out
					this.playerStartedJumpCountdown = this.$playerStartedJumpCountdown;
				}
				break;
		}
	}
}

this.checkSuspendOresratiChalenge = function()
{
	if(galaxyNumber == 7 && system.ID == 162 && (missionVariables.XeptatlsSword_status == "STAGE_130" || missionVariables.XeptatlsSword_status == "STAGE_120" || missionVariables.XeptatlsSword_status == "STAGE_100" || missionVariables.XeptatlsSword_status == "STAGE_110"))
	{
		return(true);
	}
}

this.shipWillLaunchFromStation = function(station)
{
	if(!this.OresratiChalenge)
	{
		this.OresratiChalenge = true;
		if(worldScripts["oresratichalange_main"])
		{
			worldScripts.oresratichalange_main.addToCallbacks({worldScript: "XeptatlsSword-Main", callBack: "checkSuspendOresratiChalenge"});
		}
	}
	if(station.primaryRole === "X-S-dumbell-station")
	{
		var anni = system.addShips("xs_isthargoid_disc", 1, station.position.add(station.vectorForward.multiply(-9000)).add(station.vectorUp.multiply(6000)), 0)[0];
		var targetVector = station.position.subtract(anni.position).direction();
		var angle = anni.heading.angleTo(targetVector);
		var cross = anni.heading.cross(targetVector).direction();
		anni.orientation = anni.orientation.rotate(cross,-angle);
		system.addShips("xsthargoidis", 5, player.ship.position, 1500);
		system.addShips("ISCobra", 3, player.ship.position, 1500);
		this.timerCount = 0;
		this.interstellarStation = station;
		this.warningSound.stop();
		this.insTimer = new Timer(this,this.interstellarTimer,5,5);
	}

	switch (missionVariables.XeptatlsSword_status) {
		case "STAGE_120" :
			if (station.primaryRole == "damaged-monitor-station" && system.countShipsWithRole("black-mamba-boa2") == 0) {
				system.addShipsToRoute("black-mamba-boa2", 1, 0.3,"sp");
			}
			break;
		//thargoids haunt the player forever.
		case "STAGE_170" :
			system.sendAllShipsAway();
			system.addShips("blitznest", 10, player.ship.position, 3500);
			system.addShips("thargoid", 30, player.ship.position, 5000);
			break;
		case "STAGE_310" :
			if(station.hasRole("xsheadquarters")) {
				this.$TC = system.addShips("thunderchild-2",1,station.position.add(this.$TV.multiply(25000)),100)[0];
				this.$AN = system.addShips("anni-2",1,station.position.add(this.$TV.multiply(40000)),100)[0];
				var targetVector = this.$TC.position.subtract(this.$AN.position).direction();
				var angle = this.$AN.heading.angleTo(targetVector);
				var cross = this.$AN.heading.cross(targetVector).direction();
				this.$AN.orientation = this.$AN.orientation.rotate(cross,-angle);
				var targetVector = this.$AN.position.subtract(this.$TC.position).direction();
				var angle = this.$TC.heading.angleTo(targetVector);
				var cross = this.$TC.heading.cross(targetVector).direction();
				this.$TC.orientation = this.$TC.orientation.rotate(cross,-angle);
				system.addShips("XSCobra3",3,station.position, 1500);
				system.addShips("police",3,station.position, 1500);
				system.addShips("thargoid",4,station.position, 1500);
				//make sure that at least one thargoid attacks the player
				this.$thargoidAmbush();
			}
			break;

		case "STAGE_360" :
			if(station.hasRole("xsheadquarters")) {
				system.mainPlanet.texture = "xs-estebiin-dead_cube.png";
				missionVariables.XeptatlsSword_status = "COMPLETED";
			}
			break;
	}
}

this.interstellarTimer = function()
{
	this.timerCount += 1;
	switch (this.timerCount) {
		case 1 :
			this.interstellarStation.commsMessage("Run Commander, jump to the Rift Worlds, we are doomed!",player.ship);
			//this.interstellarStation.temperature = 0.8;
			break;
		case 2 :
			this.interstellarStation.commsMessage("Annihilator within range, it is targeting us.",player.ship);
			//this.interstellarStation.temperature = 0.85;
			break;
		case 3 :
			this.interstellarStation.commsMessage("It's powering-up its weapons array. Don't look back, Commander!.",player.ship);
			//this.interstellarStation.temperature = 0.9;
			break;
		case 4 :
			this.interstellarStation.commsMessage("Run! You are our only hope. Jump to the Rift Worlds now.",player.ship);
			//this.interstellarStation.temperature = 0.95
			break;
		case 5 :
			//this.interstellarStation.explode();
			this.insTimer.stop();
			this.insTimer = null;
			break;
	}
}

this.getRidOfThargoids = function()
{
	missionVariables.XeptatlsSword_status = "STAGE_180";
	var j = this.tharGroup.ships.length-1;
	while(j >= 0)
	{
		if(this.tharGroup.ships[j].primaryRole !== "hive")
		{
			if(this.tharGroup.ships[j].primaryRole !== "xs_thargoid_disc")
			{

				//this.tharGroup.ships[j].fuel = 7.0;
				//this.tharGroup.ships[j].exitSystem();
			}
			else
			{
				this.Annihilator = this.tharGroup.ships[j];
			}
		}
		j -=1;
	}
	this.FrisbeeTimerCount = 0;
	this.materialTimer = new Timer(this,this.setMaterials1,4,4);
}
this.setMaterials1 = function()
{
	this.FrisbeeTimerCount +=1;
	if(this.FrisbeeTimerCount == 1)
	{
		this.Annihilator.setMaterials({"frisbee.png":{diffuse_map : "xs-jumpout-frisbee.png"}});
		this.Annihilator.reactToAIMessage("LIGHTS_ON");
	}
	else if(this.FrisbeeTimerCount == 2)
	{
		this.Annihilator.awardEquipment("EQ_CLOAKING_DEVICE");
		this.Annihilator.isCloaked = true;
	}
	else
	{
		this.Annihilator.remove(true);
		var j = this.tharGroup.ships.length-1;
		while(j >= 0)
		{
			if(this.tharGroup.ships[j].primaryRole !== "hive")
			{
				if(this.tharGroup.ships[j].primaryRole !== "xs_thargoid_disc")
				{
					if(this.tharGroup.ships[j].primaryRole !== "blitznestLave")
					{
						this.tharGroup.ships[j].fuel = 7.0;
						this.tharGroup.ships[j].exitSystem();
					}
				}
				else
				{
					//this.Annihilator = this.tharGroup.ships[j];
				}
			}
			j -=1;
		}

		this.materialTimer.stop();
	}
}
this.setMaterials2 = function()
{
	this.FrisbeeTimerCount +=1;
	if(this.FrisbeeTimerCount == 1)
	{
		this.Anni.setMaterials({"frisbee.png":{diffuse_map : "xs-jumpout-frisbee.png"}});
		this.Anni.reactToAIMessage("LIGHTS_ON");
	}
	else if(this.FrisbeeTimerCount == 2)
	{
		this.Anni.awardEquipment("EQ_CLOAKING_DEVICE");
		this.Anni.isCloaked = true;
	}
	else
	{
		this.Anni.remove(true);
		this.materialTimerx.stop();
	}
}
this.mesTimer = function()
{
	if (missionVariables.XeptatlsSword_status == "STAGE_240")
	{
		this.traderShip.commsMessage("[XS_MI_STAGE_245]",player.ship);
		mission.setInstructionsKey("XS_MI_STAGE_245");
		missionVariables.XeptatlsSword_status = "STAGE_245";
		mission.unmarkSystem({system: 15, name: "xeptatl"});
		mission.markSystem({system: 217, name: "xeptatl"});
	}
	else if (missionVariables.XeptatlsSword_status == "STAGE_250")
	{
		this.traderShip.commsMessage("[XS_MI_STAGE_255]",player.ship);
		mission.setInstructionsKey("XS_MI_STAGE_255");
		missionVariables.XeptatlsSword_status = "STAGE_255";
		mission.unmarkSystem({system: 196, name: "xeptatl"});
		mission.markSystem({system: 229, name: "xeptatl"});
	}
	else if (missionVariables.XeptatlsSword_status == "STAGE_290")
	{
		this.traderShip.commsMessage("[XS_MI_STAGE_295]",player.ship);
		mission.setInstructionsKey("XS_MI_STAGE_295");
		missionVariables.XeptatlsSword_status = "STAGE_295";
		mission.unmarkSystem({system: 197, name: "xeptatl"});
		mission.markSystem({system: 9, name: "xeptatl"});
	}
}
this.shipBeingAttacked = function(whom)
{
	if(missionVariables.XeptatlsSword_status == "STAGE_3a" && galaxyNumber == 5 && system.ID == 202)
	{
		if(whom.isThargoid)
		{
			this.hitCount +=1;
		}
		if(this.hitCount >5)
		{
			if(player.ship.equipmentStatus("EQ_GAL_DRIVE") == "EQUIPMENT_OK")
			{
				player.ship.removeEquipment("EQ_GAL_DRIVE");
			}
			while (player.ship.removeEquipment("EQ_GAL_DRIVE_MINE"));
			player.consoleMessage("Due to Witchspace turbulence, your Portable Galactic Hyperdrive is damaged beyond repair.",6);
			missionVariables.XeptatlsSword_status == "STAGE_3b"
		}
	}
}
this.shipWillDockWithStation = function(station)
{
	if (missionVariables.XeptatlsSword_status == "STAGE_300" && galaxyNumber == 5 && system.ID == 55 && player.ship.dockedStation.hasRole("xsheadquarters"))
	{
		this.$TC.remove(true);
	}
}

this.shipDockedWithStation = function(station) {
	if (missionVariables.XeptatlsSword_status == "STAGE_300" && galaxyNumber == 5 && system.ID == 55 && !player.ship.dockedStation.hasRole("xsheadquarters")) {
		player.ship.launch();
		player.consoleMessage("Commander, you are urgently needed at the Society HQ!");
	}
	//don't allow docking while annihilator is alive
	if ((missionVariables.XeptatlsSword_status === "STAGE_310" || missionVariables.XeptatlsSword_status === "STAGE_320" || missionVariables.XeptatlsSword_status === "STAGE_330") && galaxyNumber == 5 && system.ID == 55) {
		player.ship.launch();
		player.consoleMessage("Commander, docking is not allowed while Annihilator is around!");
	}
}

//prevent bailing out in the finale. activated on entering the system and deactivated in annihilator death event.
this.$playerStartedJumpCountdown = function () {
	player.ship.cancelHyperspaceCountdown();
	player.consoleMessage("Too much witchspace interference.");
}

// removes inappropriate TL12 station from Beanxeat system (TL9) to avoid cheating.
this.$removeHighTechStations = function () {
	system.filteredEntities(this, function (entity) {
		if (entity.isStation && entity.equivalentTechLevel > 8) {
			entity.explode();
		}
    });
}

//Annihilator countermeasures. These are activated from a ship script and deactivated from a ship script/worldscript
this.$shipSpawned = function(ship) {
	var nukes = ["EQ_QC_MINE", "EQ_RMB_CASCADE_MISSILE", "EQ_RMB_LAW_MISSILE", "EQ_RMB_OVERRIDE_MISSILE", "EQ_NUKE2_MISSILE", "EQ_HARPOON_NUKE1_MISSILE", "EQ_HARPOON_NUKE2_MISSILE", "EQ_PHOTON_MISSILE", "RANDOM_HITS_MINE"];
	if (nukes.indexOf(ship.primaryRole) !== -1) {
		player.consoleMessage("Annihilator has remotely disarmed a WMD",6);
		ship.remove(true);
	}
}

//monitor station services. These are activated/deactivated from a station script
this.$guiScreenChanged = function(to, from) {
	if (guiScreen === "GUI_SCREEN_EQUIP_SHIP") {
		mission.runScreen({
			title: "Members only",
			message: "Sorry, no service for outsiders.",
			background: "xs-no_entry.png"
		});
	}
}

//make the closest thargoid target the player
this.$thargoidAmbush = function() {
	var thargs = system.entitiesWithScanClass("CLASS_THARGOID", player.ship, 25000);
	if (thargs.length > 0)
		thargs[0].target = player.ship;
}
