"use strict";

this.name           = "XeptatlsSword-mission-helper";
this.description    = "Mission helper for f4 screen";

this.startUpComplete = function() {
	this.shipDockedWithStation(player.ship.dockedStation);
}

//view previous mission screens when xeptatl mission is running
this.shipDockedWithStation = function(station) {
	if (!missionVariables.XeptatlsSword_status) return;
	if (missionVariables.XeptatlsSword_status && missionVariables.XeptatlsSword_status.indexOf("STAGE") !== -1) {
		station.setInterface("xeptatl",{ 
			title: "Xeptatl's Sword",
			category: "Mission Log",
			summary: "View mission texts from earlier stages of the mission",
			callback: this.displayPreviousScreens.bind(this)
		});
	}
	else station.setInterface("xeptatl", null);
}

this.displayPreviousScreens = function()
{
	this.longScreen = false;
	this.longScreen2 = false;
	var keyInd = 0;
	switch (missionVariables.XeptatlsSword_status) {
		case "STAGE_0": keyInd = 1; break;
		case "STAGE_1": keyInd = 2; break;
		case "STAGE_2a": 
		case "STAGE_2d": keyInd = 3; break;
		case "STAGE_3": keyInd = 7; break;
		case "STAGE_3a":
		case "STAGE_3b": keyInd = 8; break;
		case "STAGE_4": keyInd = 9; break;
		case "STAGE_50": keyInd = 10; break;
		case "STAGE_60": keyInd = 11; break;
		case "STAGE_70": keyInd = 12; break;
		case "STAGE_72": keyInd = 13; break;
		case "STAGE_80":
		case "STAGE_90": keyInd = 14; break;
		case "STAGE_100": keyInd = 15; break;
		case "STAGE_110": keyInd = 16; break;
		case "STAGE_120":
		case "STAGE_130": keyInd = 17; break;
		case "STAGE_140": keyInd = 18; break;
		case "STAGE_150": keyInd = 19; break;
		case "STAGE_200": keyInd = 20; break;
		case "STAGE_205": keyInd = 21; break;
		case "STAGE_210": keyInd = 22; break;
		case "STAGE_215": keyInd = 23; break;
		case "STAGE_220": keyInd = 24; break;
		case "STAGE_225": keyInd = 25; break;
		case "STAGE_230": keyInd = 26; break;
		case "STAGE_235": keyInd = 27; break;
		case "STAGE_240":
		case "STAGE_245": keyInd = 28; break;
		case "STAGE_250":
		case "STAGE_255": keyInd = 29; break;
		case "STAGE_260": keyInd = 30; break;
		case "STAGE_265": keyInd = 31; break;
		case "STAGE_270": keyInd = 32; break;
		case "STAGE_275": keyInd = 33; break;
		case "STAGE_280": keyInd = 34; break;
		case "STAGE_285": keyInd = 35; break;
		case "STAGE_290": keyInd = 36; break;
		case "STAGE_300": keyInd = 37; break;
	}
	if (keyInd > 0) {
		mission.runScreen({
				title: "Xeptatl's Sword", 
				messageKey: "XS_All_Mission_Screens", 
				choicesKey: "XS_All_MissionScreens_" + keyInd,
				background: "xs-feather.png"
			}, this.previousScreenChoices
		);
	}
}

this.previousScreenChoices = function(choice) {
	var keys = new Array();
	switch(choice) {
		case "980_MS":
			keys = ["XeptatlsSword_start_2", "XS_All_Mission_Screens_prompt"];
			break;
		case "970_MS":
			keys = ["XeptatlsSword_Inbe_a", "XS_All_Mission_Screens_prompt"];
			break;
		case "960_MS":
			keys = ["XeptatlsSword_Estebiin_1", "XeptatlsSword_Estebiin_1_choices"];
			break;
		case "950_MS":
			keys = ["XeptatlsSword_Xeququti", "XS_All_Mission_Screens_prompt"];
			break;
		case "940_MS":
			keys = ["XeptatlsSword_Anve", "XS_All_Mission_Screens_prompt"];
			break;
		case "930_MS":
			keys = ["XeptatlsSword_Tezaeded", "XS_All_Mission_Screens_prompt"];
			break;
		case "920_MS":
			keys = ["XeptatlsSword_Ditere_1", "XeptatlsSword_Ditere_1_choices"];
			break;
		case "910_MS":
			keys = ["XeptatlsSword_Dioris", "XS_All_Mission_Screens_prompt"];
			break;
		case "900_MS":
			keys = ["XeptatlsSword_Qutius_1", "XS_All_Mission_Screens_prompt"];
			break;
		case "890_MS":
			keys = ["XeptatlsSword_Beanxeat_1", "XS_All_Mission_Screens_prompt"];
			break;
		case "880_MS":
			keys = ["XeptatlsSword_Inlabe_1", "XeptatlsSword_Inlabe_1_choices"];
			break;
		case "870_MS":
			keys = ["XeptatlsSword_Tiared_1", "XS_All_Mission_Screens_prompt"];
			break;
		case "860_MS":
			keys = ["XeptatlsSword_ResearchStation_1", "XeptatlsSword_ResearchStation_1_choices"];
			break;
		case "850_MS":
			keys = ["XeptatlsSword_Articeso", "XS_All_Mission_Screens_prompt"];
			break;
		case "840_MS":
			keys = ["XeptatlsSword_Onteised", "XS_All_Mission_Screens_prompt"];
			break;
		case "830_MS":
			keys = ["XeptatlsSword_Oresrati", "XS_All_Mission_Screens_prompt"];
			break;
		case "820_MS":
			keys = ["XeptatlsSword_Oresrati_ResearchStation", "XS_All_Mission_Screens_prompt"];
			break;
		case "810_MS":
			keys = ["XeptatlsSword_Leesti_ResearchStation", "XeptatlsSword_Leesti_ResearchStation_choices"];
			break;
		case "800_MS":
			keys = ["XeptatlsSword_Leesti", "XS_All_Mission_Screens_prompt"];
			break;
		case "790_MS":
			keys = ["XeptatlsSword_Lave_a1", "XeptatlsSword_Lave_a1_choices"];
			break;
		case "780_MS":
			keys = ["XeptatlsSword_Tionisla", "XeptatlsSword_Tionisla_choices"];
			break;
		case "770_MS":
			keys = ["XeptatlsSword_Vearin", "XS_All_Mission_Screens_prompt"];
			break;
		case "760_MS":
			keys = ["XeptatlsSword_Lasoce", "XS_All_Mission_Screens_prompt"];
			break;
		case "750_MS":
			keys = ["XeptatlsSword_Soiserla", "XS_All_Mission_Screens_prompt"];
			break;
		case "740_MS":
			keys = ["XeptatlsSword_Birera", "XS_All_Mission_Screens_prompt"];
			break;
		case "730_MS":
			keys = ["XeptatlsSword_Aaanqu", "XS_All_Mission_Screens_prompt"];
			break;
		case "720_MS":
			keys = ["XeptatlsSword_Soralaat", "XS_All_Mission_Screens_prompt"];
			break;
		case "710_MS":
			keys = ["XeptatlsSword_Geerin", "XS_All_Mission_Screens_prompt"];
			break;
		case "700_MS":
			keys = ["XeptatlsSword_Aroratla", "XS_All_Mission_Screens_prompt"];
			break;
		case "690_MS":
			keys = ["XeptatlsSword_Xeaten", "XS_All_Mission_Screens_prompt"];
			break;
		case "680_MS":
			keys = ["XeptatlsSword_Quinmabe", "XS_All_Mission_Screens_prompt"];
			break;
		case "670_MS":
			keys = ["XeptatlsSword_Ceenbion", "XS_All_Mission_Screens_prompt"];
			break;
		case "660_MS":
			keys = ["XeptatlsSword_Tecexe", "XS_All_Mission_Screens_prompt"];
			break;
		case "650_MS":
			keys = ["XeptatlsSword_Zalexe", "XS_All_Mission_Screens_prompt"];
			break;
		case "640_MS":
			keys = ["XeptatlsSword_Biradi", "XS_All_Mission_Screens_prompt"];
			break;
		case "630_MS":
			keys = ["XeptatlsSword_Atmaa", "XS_All_Mission_Screens_prompt"];
			break;
		case "620_MS":
			keys = ["XeptatlsSword_Dioris_2", "XeptatlsSword_Dioris_2_choices"];
			break;
		case "1_Cont":
			keys = ["XeptatlsSword_Estebiin_2", "XeptatlsSword_Estebiin_2_choices"];
			break;
		case "1a_Cont":
			keys = ["XeptatlsSword_Estebiin_3", "XS_All_Mission_Screens_prompt"];
			break;
		case "2_Cont":
			keys = ["XeptatlsSword_Ditere_2", "XS_All_Mission_Screens_prompt"];
			break;
		case "3_Cont":
			keys = ["XeptatlsSword_Inlabe_2", "XS_All_Mission_Screens_prompt"];
			break;
		case "4a_Cont":
			keys = ["XeptatlsSword_ResearchStation_2", "XeptatlsSword_ResearchStation_2_choices"];
			break;
		case "4b_Cont":
			keys = ["XeptatlsSword_ResearchStation_3", "XS_All_Mission_Screens_prompt"];
			break;
		case "5_Cont":
			keys = ["XeptatlsSword_Leesti_ResearchStation_1", "XS_All_Mission_Screens_prompt"];
			break;
		case "6_Cont":
			keys = ["XeptatlsSword_Lave_a2", "XeptatlsSword_Lave_a2_choices"];
			break;
		case "6a_Cont":
			keys = ["XeptatlsSword_Lave_a3", "XS_All_Mission_Screens_prompt"];
			break;
		case "16_Cont":
			keys = ["XeptatlsSword_Tionisla_2", "XS_All_Mission_Screens_prompt"];
			break;
		case "17_Cont":
			keys = ["XeptatlsSword_Dioris_3", "XS_All_Mission_Screens_prompt"];
			break;
		case "98_return":
			if(this.longScreen) {
				this.longScreen = false;
				keys = ["XS_All_Mission_Screens", "XS_All_MissionScreens_20a"];
			}
			else {
				this.displayPreviousScreens();
				return;
			}
			break;
		case "99_BPrev":
			this.longScreen = true;
			keys = ["XS_All_Mission_Screens", "XS_All_MissionScreens_20a"];
			break;
		case "99_APrev":
			this.displayPreviousScreens();
			break;
	}
	if (keys.length > 0)
		mission.runScreen({
				title: "Xeptatl's Sword",
				messageKey: keys[0],
				choicesKey: keys[1],
				background: "xs-feather.png"
			}, this.previousScreenChoices
		);
}
